#include "MainFrame.h"
#include "resource.h"
#include "CMyDialog.h"
#include "C_MYDIALOG1.h"


BEGIN_MESSAGE_MAP( CMainFrame, CFrameWnd)
	ON_WM_PAINT()
	ON_COMMAND( ID_New, newTree)
	ON_COMMAND( ID_TREE_INFO, newinfo)
	ON_COMMAND( ID_EXIT, treeexit)
	ON_UPDATE_COMMAND_UI(ID_TREE_INFO, OnUpdateInfo)
END_MESSAGE_MAP()

int MAX( int a, int b)
{
	return (a>b) ? a : b;
}

int maxdepth( Node* x)
{
	if (x!=NULL) return (1+MAX(maxdepth(x->left),maxdepth(x->right)));
	else return 0;
}

CMainFrame::CMainFrame()  //Constructor
{
	Create(NULL,"Tree Application",
		WS_OVERLAPPEDWINDOW & ~WS_MAXIMIZEBOX & ~WS_THICKFRAME,
		CRect(0,0,800,573),NULL,MAKEINTRESOURCE(IDR_MENU1));
	GetClientRect( MRec);

	HICON hicon=AfxGetApp()->LoadIcon(IDI_ICON1);
    SetIcon(hicon,FALSE);
	SetIcon(hicon,TRUE);

	T=NULL;
	myflag = false;
};

int pow2( int n)
{
	int res = 1;
	for ( int i = 0; i<n; i++)
		res *= 2;
	return res;
}


void CMainFrame::draw( Node* T, int deg, int x)
{
	CClientDC dc(this);
	if ( T == NULL ) return;
	int y = ( deg + 1 ) * yunit + 12;
	int nextxunit = 700 / ( pow2(deg+1)+1 );
	int leftchildx = x - nextxunit / 2;
	int rightchildx = x + nextxunit / 2;
	dc.MoveTo( x , y );
	if ( T->left != NULL )
	{
		dc.LineTo( leftchildx,y+yunit);
		dc.MoveTo( x , y);
	}
	if ( T->right != NULL )
		dc.LineTo( rightchildx,y+yunit);
	CBrush color;
	color.CreateSolidBrush( RGB(240,240,50) );
	CBrush *pBrush = dc.SelectObject(&color);		
	dc.Ellipse(x-10,y-10,x+10,y+10);
	CString str;
	str.Format("%c",T->data);
	dc.SetBkMode(TRANSPARENT);
	dc.DrawText(str,-1,CRect(x-10,y-10,x+10,y+10),
		DT_SINGLELINE | DT_CENTER|DT_VCENTER);
	dc.SelectObject(pBrush);
	draw(T->left,deg+1,leftchildx);
	draw(T->right,deg+1,rightchildx);
	myflag = true;
}


void CMainFrame::OnPaint()
{
	CPaintDC dc(this);
		
	CBrush blue;
	blue.CreateSolidBrush( RGB(110,90,180) );
	CBrush *pBrush = dc.SelectObject(&blue);
	
	dc.Rectangle(45,12,745,512);	
	dc.SelectObject(pBrush);
	
	if (T) draw(parent,0,395);
	
}

void CMainFrame::newTree()
{
	CClientDC dc (this);
	CMyDialog Dlg(this);
	if(Dlg.DoModal() == IDOK)
	{
		infixstr=Dlg.infix;
		prefixstr=Dlg.prefix;
		postfixstr=Dlg.postfix;
		
		try{
			if (infixstr==""){
				T = new Tree(postfixstr,prefixstr,3);
				infixstr = T->infixer(T->getHead());
			}else if (postfixstr==""){
				T = new Tree(infixstr,prefixstr,1);
				postfixstr = T->postfixer(T->getHead());
			}else if (prefixstr==""){
				T = new Tree(infixstr,postfixstr,2);
				prefixstr = T->prefixer(T->getHead());
			}

			possible = T->getPossible();

			parent = T->getHead();
			yunit = 500/ (maxdepth(parent)+1);
			Invalidate();
		}catch(Except & e){
			MessageBox(cs2string(e.message),"ERROR",MB_ICONERROR);
		}
	}
}

CString CMainFrame::cs2string(string what){
	int end = what.length();
	CString retval;

	for(int count = 0;count < end;count++)
		retval += what[count];

	return retval;
}

void CMainFrame::newinfo(){
	CMyDialog1 Dlg(this,cs2string(infixstr),cs2string(prefixstr),cs2string(postfixstr),possible);
	if(Dlg.DoModal() == IDOK)
	{
		return;
	}
}

void CMainFrame::treeexit(){
	SendMessage( WM_CLOSE );
}

void CMainFrame::OnUpdateInfo(CCmdUI* pCmdUI){
	pCmdUI->Enable(myflag);
}
